KComboBox Class Reference

`#include <kcombobox.h>`

Inheritance diagram for KComboBox:

## Public Slots

void | rotateText (KCompletionBase::KeyBindingType type)
virtual void | setCompletedText (const QString &)
void | setCompletedItems (const QStringList &items)
void | setCurrentItem (const QString &item, bool insert=false, int index=-1)
void | setCurrentItem (int index)

## Signals

void | returnPressed ()
void | returnPressed (const QString &)
void | completion (const QString &)
void | substringCompletion (const QString &)
void | textRotation (KCompletionBase::KeyBindingType)
void | completionModeChanged (KGlobalSettings::Completion)
void | aboutToShowContextMenu (QPopupMenu *p)

## Public Member Functions

| KComboBox (QWidget *parent=0, const char *name=0)
| KComboBox (bool rw, QWidget *parent=0, const char *name=0)
virtual | ~KComboBox ()
void | setEditURL (const KURL &url)
void | insertURL (const KURL &url, int index=-1)
void | insertURL (const QPixmap &pixmap, const KURL &url, int index=-1)
void | changeURL (const KURL &url, int index)
void | changeURL (const QPixmap &pixmap, const KURL &url, int index)
int | cursorPosition () const
virtual void | setAutoCompletion (bool autocomplete)
bool | autoCompletion () const
virtual void | setContextMenuEnabled (bool showMenu)
bool | isContextMenuEnabled () const
void | setURLDropsEnabled (bool enable)
bool | isURLDropsEnabled () const
bool | contains (const QString &text) const
void | setTrapReturnKey (bool trap)
bool | trapReturnKey () const
virtual bool | eventFilter (QObject *, QEvent *)
KCompletionBox * | completionBox (bool create=true)
virtual void | setLineEdit (QLineEdit *)
Public Member Functions inherited from KCompletionBase
KCompletion * | completionObject (bool hsig=true)
virtual void | setCompletionObject (KCompletion *compObj, bool hsig=true)
virtual void | setHandleSignals (bool handle)
bool | isCompletionObjectAutoDeleted () const
void | setAutoDeleteCompletionObject (bool autoDelete)
void | setEnableSignals (bool enable)
bool | handleSignals () const
bool | emitSignals () const
virtual void | setCompletionMode (KGlobalSettings::Completion mode)
KGlobalSettings::Completion | completionMode () const
bool | setKeyBinding (KeyBindingType item, const KShortcut &key)
const KShortcut & | getKeyBinding (KeyBindingType item) const
void | useGlobalKeyBindings ()
virtual void | setCompletedText (const QString &text)=0
virtual void | setCompletedItems (const QStringList &items)=0
KCompletion * | compObj () const

## Protected Slots

virtual void | itemSelected (QListBoxItem *)
virtual void | makeCompletion (const QString &)

## Protected Member Functions

virtual void | setCompletedText (const QString &, bool)
virtual void | create (WId=0, bool initializeWindow=true, bool destroyOldWindow=true)
virtual void | wheelEvent (QWheelEvent *ev)
virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KCompletionBase
KeyBindingMap | getKeyBindings () const
void | setDelegate (KCompletionBase *delegate)
KCompletionBase * | delegate () const

## Properties

bool | autoCompletion
bool | contextMenuEnabled
bool | urlDropsEnabled
bool | trapReturnKey

## Additional Inherited Members

Public Types inherited from KCompletionBase
enum | KeyBindingType

## Detailed Description

An enhanced combo box.

A combined button, line-edit and a popup list widget.

Detail
This widget inherits from QComboBox and implements the following additional functionalities: a completion object that provides both automatic and manual text completion as well as text rotation features, configurable key-bindings to activate these features, and a popup-menu item that can be used to allow the user to change the text completion mode on the fly.

To support these new features KComboBox emits a few additional signals such as completion( const QString& ) and textRotation( KeyBindgingType ). The completion signal can be connected to a slot that will assist the user in filling out the remaining text while the rotation signal can be used to traverse through all possible matches whenever text completion results in multiple matches. Additionally, a returnPressed() and a returnPressed( const QString& ) signals are emitted when the user presses the Enter/Return key.

KCombobox by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or explicitly use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KComboBox will by default handle text rotation and completion events internally whenever a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use `setHandleSignals(bool)` or alternatively set the boolean parameter in the `setCompletionObject` call to false.

Beware: The completion object can be deleted on you, especially if a call such as setEditable(false) is made. Store the pointer at your own risk, and consider using QGuardedPtr<KCompletion>.

The default key-bindings for completion and rotation is determined from the global settings in KStdAccel. These values, however, can be overridden locally by invoking KCompletionBase::setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by usning setKeyBinding() with the default second argument.

A non-editable combobox only has one completion mode, `CompletionAuto`. Unlike an editable combobox the CompletionAuto mode, works by matching any typed key with the first letter of entries in the combobox. Please note that if you call setEditable( false ) to change an editable combobox to a non-editable one, the text completion object associated with the combobox will no longer exist unless you created the completion object yourself and assigned it to this widget or you called setAutoDeleteCompletionObject( false ). In other words do not do the following:

KComboBox* combo = new KCompletionBox(true, this, "mywidget");
KCompletion* comp = combo->completionObject();
combo->setEditable( false );
comp->clear(); // CRASH: completion object does not exist anymore.

A read-only KComboBox will have the same background color as a disabled KComboBox, but its foreground color will be the one used for the read-write mode. This differs from QComboBox's implementation and is done to give visual distinction between the three different modes: disabled, read-only, and read-write.

Usage
To enable the basic completion feature:

KComboBox *combo = new KComboBox( true, this, "mywidget" );
KCompletion *comp = combo->completionObject();
// Connect to the return pressed signal - optional
connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&)));
// Provide the to be completed strings. Note that those are separate from the combo's
// contents.
comp->insertItems( someQStringList );

To use your own completion object:

KComboBox *combo = new KComboBox( this,"mywidget" );
KURLCompletion *comp = new KURLCompletion();
combo->setCompletionObject( comp );
// Connect to the return pressed signal - optional
connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&)));

Note that you have to either delete the allocated completion object when you don't need it anymore, or call setAutoDeleteCompletionObject( true );

Miscellaneous function calls:

// Tell the widget not to handle completion and rotation
combo->setHandleSignals( false );
// Set your own completion key for manual completions.
combo->setKeyBinding( KCompletionBase::TextCompletion, Qt::End );
// Hide the context (popup) menu
combo->setContextMenuEnabled( false );

Author
  Dawit Alemayehu adawi.nosp@m.t@kd.nosp@m.e.org

Definition at line 144 of file kcombobox.h.

## Constructor & Destructor Documentation

KComboBox::KComboBox | ( | QWidget * | parent = `0`,
|  | const char * | name = `0`
| ) |  |

Constructs a read-only or rather select-only combo box with a parent object and a name.

Parameters

  parent | The parent object of this widget
  name | The name of this widget

Definition at line 59 of file kcombobox.cpp.

KComboBox::KComboBox | ( | bool | rw,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`
| ) |  |

Constructs a "read-write" or "read-only" combo box depending on the value of the first argument( `rw` ) with a parent, a name.

Parameters

  rw | When `true`, widget will be editable.
  parent | The parent object of this widget.
  name | The name of this widget.

Definition at line 65 of file kcombobox.cpp.

KComboBox::~KComboBox | ( |  | ) |

virtual

Destructor.

Definition at line 77 of file kcombobox.cpp.

## Member Function Documentation

void KComboBox::aboutToShowContextMenu | ( | QPopupMenu * | p | ) |

signal

Emitted before the context menu is displayed.

The signal allows you to add your own entries into the context menu. Note that you MUST NOT store the pointer to the QPopupMenu since it is created and deleted on demand. Otherwise, you can crash your app.

Parameters

  p | the context menu about to be displayed

bool KComboBox::autoCompletion | ( |  | ) | const

inline

Re-implemented from QComboBox.

Returns `true` if the current completion mode is set to automatic. See its more comprehensive replacement completionMode().

Returns
  `true` when completion mode is automatic.

Definition at line 246 of file kcombobox.h.

void KComboBox::changeURL | ( | const KURL & | url,
|  | int | index
| ) |  |

Replaces the item at position `index` with `url`.

KURL::prettyURL() is used so that the url is properly decoded for displaying.

Definition at line 212 of file kcombobox.cpp.

void KComboBox::changeURL | ( | const QPixmap & | pixmap,
|  | const KURL & | url,
|  | int | index
| ) |  |

Replaces the item at position `index` with `url` and pixmap `pixmap`.

KURL::prettyURL() is used so that the url is properly decoded for displaying.

Definition at line 217 of file kcombobox.cpp.

void KComboBox::completion | ( | const QString & |  | ) |

signal

Emitted when the completion key is pressed.

The argument is the current text being edited.

Note that this signal is not available when the widget is non-editable or the completion mode is set to `KGlobalSettings::CompletionNone`.

KCompletionBox * KComboBox::completionBox | ( | bool | create = `true` | ) |

Returns
  the completion-box, that is used in completion mode KGlobalSettings::CompletionPopup and KGlobalSettings::CompletionPopupAuto. This method will create a completion-box by calling KLineEdit::completionBox, if none is there, yet.

Parameters

  create | Set this to false if you don't want the box to be created i.e. to test if it is available.

Definition at line 228 of file kcombobox.cpp.

void KComboBox::completionModeChanged | ( | KGlobalSettings::Completion |  | ) |

signal

Emitted whenever the completion mode is changed by the user through the context menu.

bool KComboBox::contains | ( | const QString & | text | ) | const

Convenience method which iterates over all items and checks if any of them is equal to `text`.

If `text` is an empty string, `false` is returned.

Returns
  `true` if an item with the string `text` is in the combobox.

Definition at line 93 of file kcombobox.cpp.

void KComboBox::create | ( | WId | id = `0`,
|  | bool | initializeWindow = `true`,
|  | bool | destroyOldWindow = `true`
| ) |  |

protected virtual

Reimplemented for internal reasons, the API is not affected.

Definition at line 236 of file kcombobox.cpp.

int KComboBox::cursorPosition | ( |  | ) | const

inline

Returns the current cursor position.

This method always returns a -1 if the combo-box is not editable (read-write).

Returns
  Current cursor position.

Definition at line 223 of file kcombobox.h.

bool KComboBox::eventFilter | ( | QObject * | o,
|  | QEvent * | ev
| ) |  |

virtual

Re-implemented for internal reasons.

API not affected.

Definition at line 178 of file kcombobox.cpp.

void KComboBox::insertURL | ( | const KURL & | url,
|  | int | index = `-1`
| ) |  |

Inserts `url` at position `index` into the combobox.

The item will be appended if `index` is negative. KURL::prettyURL() is used so that the url is properly decoded for displaying.

Definition at line 202 of file kcombobox.cpp.

void KComboBox::insertURL | ( | const QPixmap & | pixmap,
|  | const KURL & | url,
|  | int | index = `-1`
| ) |  |

Inserts `url` with the pixmap &p pixmap at position `index` into the combobox.

The item will be appended if `index` is negative. KURL::prettyURL() is used so that the url is properly decoded for displaying.

Definition at line 207 of file kcombobox.cpp.

bool KComboBox::isContextMenuEnabled | ( |  | ) | const

inline

Returns `true` when the context menu is enabled.

Definition at line 270 of file kcombobox.h.

bool KComboBox::isURLDropsEnabled | ( |  | ) | const

Returns `true` when decoded URL drops are enabled.

Definition at line 137 of file kcombobox.cpp.

virtual void KComboBox::itemSelected | ( | QListBoxItem * |  | ) |

inline protected virtual slot

Deprecated:

Definition at line 460 of file kcombobox.h.

void KComboBox::makeCompletion | ( | const QString & | text | ) |

protected virtual slot

Completes text according to the completion mode.

Note: this method is `not` invoked if the completion mode is set to CompletionNone. Also if the mode is set to `CompletionShell` and multiple matches are found, this method will complete the text to the first match with a beep to inidicate that there are more matches. Then any successive completion key event iterates through the remaining matches. This way the rotation functionality is left to iterate through the list as usual.

Definition at line 155 of file kcombobox.cpp.

void KComboBox::returnPressed | ( |  | ) |

signal

Emitted when the user presses the Enter key.

Note that this signal is only emitted when the widget is editable.

void KComboBox::returnPressed | ( | const QString & |  | ) |

signal

Emitted when the user presses the Enter key.

The argument is the current text being edited. This signal is just like returnPressed() except it contains the current text as its argument.

Note that this signal is only emitted when the widget is editable.

void KComboBox::rotateText | ( | KCompletionBase::KeyBindingType | type | ) |

slot

Iterates through all possible matches of the completed text or the history list.

Depending on the value of the argument, this function either iterates through the history list of this widget or the all possible matches in whenever multiple matches result from a text completion request. Note that the all-possible-match iteration will not work if there are no previous matches, i.e. no text has been completed and the *nix shell history list rotation is only available if the insertion policy for this widget is set either `QComobBox::AtTop` or `QComboBox::AtBottom`. For other insertion modes whatever has been typed by the user when the rotation event was initiated will be lost.

Parameters

  type | The key-binding invoked.

Definition at line 171 of file kcombobox.cpp.

void KComboBox::setAutoCompletion | ( | bool | autocomplete | ) |

virtual

Re-implemented from QComboBox.

If `true`, the completion mode will be set to automatic. Otherwise, it is defaulted to the global setting. This method has been replaced by the more comprehensive setCompletionMode().

Parameters

  autocomplete | Flag to enable/disable automatic completion mode.

Definition at line 107 of file kcombobox.cpp.

void KComboBox::setCompletedItems | ( | const QStringList & | items | ) |

slot

Sets `items` into the completion-box if completionMode() is CompletionPopup.

The popup will be shown immediately.

Definition at line 222 of file kcombobox.cpp.

void KComboBox::setCompletedText | ( | const QString & | text | ) |

virtual slot

Sets the completed text in the line-edit appropriately.

This function is a re-implementation of `setCompletedText`.

Definition at line 149 of file kcombobox.cpp.

void KComboBox::setContextMenuEnabled | ( | bool | showMenu | ) |

virtual

Enables or disable the popup (context) menu.

This method only works if this widget is editable, i.e. read-write and allows you to enable/disable the context menu. It does nothing if invoked for a none-editable combo-box. Note that by default the mode changer item is made visiable whenever the context menu is enabled. Use hideModechanger() if you want to hide this item. Also by default, the context menu is created if this widget is editable. Call this function with the argument set to false to disable the popup menu.

Parameters

  showMenu | If `true`, show the context menu.

Definition at line 124 of file kcombobox.cpp.

void KComboBox::setCurrentItem | ( | const QString & | item,
|  | bool | insert = `false`,
|  | int | index = `-1`
| ) |  |

slot

Selects the first item that matches `item`.

If there is no such item, it is inserted at position `index` if `insert` is true. Otherwise, no item is selected.

Definition at line 305 of file kcombobox.cpp.

void KComboBox::setCurrentItem | ( | int | index | ) |

inline slot

Simply calls QComboBox' implementation.

Only here to not become shadowed.

Definition at line 453 of file kcombobox.h.

void KComboBox::setEditURL | ( | const KURL & | url | ) |

Sets `url` into the edit field of the combobox.

It uses KURL::prettyURL() so that the url is properly decoded for displaying.

Definition at line 197 of file kcombobox.cpp.

void KComboBox::setLineEdit | ( | QLineEdit * | edit | ) |

virtual

Re-implemented for internal reasons.

API remains unaffected. NOTE: Only editable comboboxes can have a line editor. As such any attempt to assign a line-edit to a non-editable combobox will simply be ignored.

Definition at line 248 of file kcombobox.cpp.

void KComboBox::setTrapReturnKey | ( | bool | trap | ) |

By default, KComboBox recognizes Key_Return and Key_Enter and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.

Call this method with `trap` equal to true to make KComboBox stop these events. The signals will still be emitted of course.

Only affects read-writable comboboxes.

See also
  setTrapReturnKey()

Definition at line 183 of file kcombobox.cpp.

void KComboBox::setURLDropsEnabled | ( | bool | enable | ) |

Enables/Disables handling of URL drops.

If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behavior of QComboBox is used, which inserts the encoded URL.

Parameters

  enable | If `true`, insert decoded URLs

Definition at line 131 of file kcombobox.cpp.

void KComboBox::substringCompletion | ( | const QString & |  | ) |

signal

Emitted when the shortcut for substring completion is pressed.

void KComboBox::textRotation | ( | KCompletionBase::KeyBindingType |  | ) |

signal

Emitted when the text rotation key-bindings are pressed.

The argument indicates which key-binding was pressed. In this case this can be either one of four values: `PrevCompletionMatch`, `NextCompletionMatch`, `RotateUp` or `RotateDown`. See `setKeyBinding()` for details.

Note that this signal is NOT emitted if the completion mode is set to CompletionNone.

bool KComboBox::trapReturnKey | ( |  | ) | const

Returns
  `true` if keyevents of Key_Return or Key_Enter will be stopped or if they will be propagated.

See also
  setTrapReturnKey ()

The documentation for this class was generated from the following files:

- kcombobox.h
- kcombobox.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys